#! /usr/bin/python


"""//Web to administrate scheduler resources//
 
- > This Web service can be use to register the cloud resources available to the scheduler.
 
- File: admin_dg.py

- Notes: 
 - A database configuration file named "db.cfg" must be present in the directory.

"""
import sys
import os
sys.path.append(os.path.join(sys.path[0],".."))
os.chdir(sys.path[0])
from tools import db_func
from tools import cgi_func
from tools import log_func
log=log_func.get_spequlos_log(__file__)

cgi_func.print_header()

if not cgi_func.get_form_value('del') is None:
    dg_name = cgi_func.get_form_value('del')
    print "<p>Deleting desktop grid %s</p>" % dg_name

    conn=db_func.connect(db_func.read_db_config(os.path.join(sys.path[0],"db.cfg")))
    c=conn.cursor()
    try:
        c.execute("DELETE FROM DesktopGrid WHERE dg_name='%s'" % dg_name)
    except db_func.DBError as e:
        log.error("Error during the SQL command execution !")
        log.error(e)
    db_func.disconnect(conn)
    
    print "<p>Desktop Grid Deleted</p>" 
    print "<p> <a href='admin_dg.py'>Go back</a></p>"

elif (cgi_func.get_form_value('Desktop_Grid_Name') is None) or  (cgi_func.get_form_value('Desktop_Grid_Type') is None) or  (cgi_func.get_form_value('Desktop_Grid_Plugin_URL') is None):
    
    print "<p>Register a new desktop grid (currently, the only types supported are 'XWHEP' or 'BOINC')</p>"
    cgi_func.print_form(['Desktop_Grid_Name','Desktop_Grid_Type','Desktop_Grid_Plugin_URL'])

    print "<p>Desktop Grid already registered:</p><table border=1>"
    conn=db_func.connect(db_func.read_db_config(os.path.join(sys.path[0],"db.cfg")))
    c=conn.cursor()
    try:
        c.execute("SELECT dg_name, dg_type, dg_plugin_url FROM DesktopGrid")
    except db_func.DBError as e:
        log.error("Error during the SQL command execution !")
        log.error(e)
    res=c.fetchall()
    db_func.disconnect(conn)
    
    print "<tr><td>Desktop Grid Name</td><td>Desktop Grid Type</td><td>Desktop Grid Plugin URL</td></tr>" 

    for l in res:
        print "<tr><td>%s</td><td>%s</td><td>%s</td><td><a href=admin_dg.py?del=%s>Delete</a></td>" \
            % (l[0],l[1],l[2],l[0]) 

    print "</table>"

else:
    dg_name = cgi_func.get_form_value('Desktop_Grid_Name')
    dg_type = cgi_func.get_form_value('Desktop_Grid_Type')
    dg_plugin_url = cgi_func.get_form_value('Desktop_Grid_Plugin_URL')

    conn=db_func.connect(db_func.read_db_config(os.path.join(sys.path[0],"db.cfg")))
    c=conn.cursor()
    try:
        c.execute("INSERT DesktopGrid(dg_name,dg_type,dg_plugin_url) VALUES ('%s','%s','%s')" % (dg_name,dg_type,dg_plugin_url))
    except db_func.DBError as e:
        log.error("Error during the SQL command execution !")
        log.error(e)
    db_func.disconnect(conn)
    print "<p> Desktop Grid registered !</p>"
    print "<p> <a href='admin_dg.py'>Go back</a></p>"

cgi_func.print_footer()

